program fractal;
uses Dos, Crt, Graph;
{---------------------------------------------------------------------}
type TComplex = object
   x : real;
   y : real;
   constructor Init(Argx : real; Argy : real);
   function Module : real;
   procedure Show;
end;
{---------------------------------------------------------------------}
function TComplex.Module : real;
begin
   Module := sqrt(x*x + y*y);
end;
{---------------------------------------------------------------------}
constructor TComplex.Init(Argx : real; Argy : real);
begin
   x := Argx;
   y := Argy;
end;
{---------------------------------------------------------------------}
procedure TComplex.Show;
begin
   writeln;
   write(x, ' + ', y, ' i');
end;
{---------------------------------------------------------------------}
procedure Add( Z1, Z2 : TComplex; var Z3 : TComplex);
begin
   Z3.x := Z1.x + Z2.x;
   Z3.y := Z1.y + Z2.y;
end;
procedure Sub( Z1, Z2 : TComplex; var Z3 : TComplex);
begin
   Z3.x := Z1.x - Z2.x;
   Z3.y := Z1.y - Z2.y;
end;
{---------------------------------------------------------------------}
procedure Mult( Z1, Z2 : TComplex; var Z3 : TComplex);
begin
   Z3.x := Z1.x * Z2.x - Z1.y * Z2.y;
   Z3.y := Z1.x * Z2.y + Z2.x * Z1.y;
end;
{---------------------------------------------------------------------}
const
   left=-0.8;
   top=0.0;
   right=0.8;
   bottom=-1.5;
   MaxModule = 3;
var
   grDriver, grMode : integer;
   xi, yi, i : integer;
   Z, Z0, ZTmp1, ZTmp2, ZTmp3 : TComplex;
   C : TComplex;
   xcells, ycells, xPixelSize, yPixelSize : integer;
   xstep, ystep : real;
   mode : byte;
   M : real;
{---------------------------------------------------------------------}
begin
   grDriver := VGA;
   grMode := VGAHI;
   initgraph(grDriver, grMode, '');
{const init}
   C.x := 1;
   C.y := 0;
   mode := 1;
   cleardevice;
   case mode of
       1 : begin
           xcells:=640;
           ycells:=480;
           end;
       2 : begin
           xcells:=320;
           ycells:=240;
           end;
       4 : begin
           xcells:=160;
           ycells:=120;
           end;
       8 : begin
           xcells:=80;
           ycells:=60;
           end;
       16 : begin
           xcells:=40;
           ycells:=30;
           end;
   end;

   xPixelSize:=640 div xcells;
   yPixelSize:=480 div ycells;
   xstep:=(right-left)/xcells;
   ystep:=(top-bottom)/ycells;

   for xi := 1 to xcells do
   begin
       for yi := 1 to ycells do
       begin
           Z.Init(left + (xi-1)*xstep, bottom + (yi-1)*ystep);
           for i := 1 to 50 do
           begin
               Mult(Z, Z, ZTmp1);                 { Z*Z }
               Mult(Z, ZTmp1, ZTmp3);             { Z*Z*Z }
               Mult(C, Z, ZTmp2);                 { C*Z }
               Add(ZTmp3, ZTmp2, Z);              { Z := Z*Z + C*Z }
               M := Z.Module;
               if (M > MaxModule) then
               begin
                   break;
               end;
           end;
           if (M <= MaxModule) then
           begin
               setfillstyle(SOLIDFILL, Trunc(M*10000));
               bar((xi-1)*xPixelSize, 480-(yi-1)*yPixelSize, (xi-1)*xPixelSize+mode, 480-(yi-1)*yPixelSize+mode);
           end;
       end;
   end;
   ReadKey;
   closegraph;
end.